# Trueface SDK

## Getting started
The sdk library and the header files `tf_sdk.h` and `tf_data_types.h` can be found in `trueface_sdk/`.
Some models may need to be downloaded to be loaded at runtime (running the inference function will throw an error if the model is not found).
For these models, run the scripts located in the `download_models` directory to obtain the models. Be sure to specify the `modelsPath` configuration option.

### C++ Sample Code
Navigate to `c++/` and build and run the sample code using the build instructions at the top of the files. 
The sample code demonstrates the basic functionality of the SDK and provides sample command-line commands to compile an application linking against the SDK.
To explore full functionality, please consult the header files and the documentation.

### Python Bindings 
The C++ SDK features python bindings for all the API functions and data types.
To run the python sample code, obtain a version of the Trueface [SDK python bindings](https://reference.trueface.ai/cpp/master/latest/py/index.html)
 library and place it in `python/`. Note, python bindings are not available for Windows.

### Documentation
The C++ SDK documentation can be found [here](https://reference.trueface.ai/cpp/master/latest/index.html) 

### Python bindings documentation
The documentation for the python bindings can be found [here](https://reference.trueface.ai/cpp/master/latest/py/index.html)

### Sample Apps
Sample apps using the C++ SDK can be found [here](https://github.com/getchui/sample-apps). 
These sample apps extend the scope of the sample code and demonstrate more complete applications such as real-time streaming apps.

### Benchmarks
To run speed benchmarks, navigate to `benchmarks/`.
You can also consult the `CMakeLists.txt` file in the `benchmarks/` directory to learn how to compile an application using `cmake` and `make`.

### FAQ
A list of frequently asked questions with answers can be found [here](https://reference.trueface.ai/cpp/master/latest/faq.html)